#include <bits/stdc++.h>

using namespace std;


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> v(n), ans(n), used(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        x--;
        used[x] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            continue;
        }
        int cnt = 0;
        for (int j = i; j < n; j++) {
            if (cnt > t || (i != j && used[j])) {
                break;
            }
            ans[i] = max((j - i) + (t - cnt) / v[j], ans[i]);
            cnt += v[j];
        }
        cnt = 0;
        for (int j = i; j >= 0; j--) {
            if (cnt > t || (i != j && used[j])) {
                break;
            }
            ans[i] = max(ans[i], i - j + (t - cnt) / v[j]);
            cnt += v[j];
        }
    }
    int res = 0;
    for (int i = 0; i < n; i++) {
        res = max(res, ans[i]);
    }
    cout << res;
}
